libstdc++: std::ctype< wchar_t > Class Reference

libstdc++

std::ctype< wchar_t > Class Reference
Locales

`#include <locale_facets.h>`

Inheritance diagram for std::ctype< wchar_t >:
[legend]

## Public Types
typedef const int * | __to_type
typedef wctype_t | __wmask_type
typedef wchar_t | char_type
typedef __ctype_abstract_base< wchar_t >::mask | mask

## Public Member Functions
| ctype (__c_locale __cloc, size_t __refs=0)
| ctype (size_t __refs=0)
const char_type * | is (const char_type *__lo, const char_type *__hi, mask *__vec) const
bool | is (mask __m, char_type __c) const
char | narrow (char_type __c, char __dfault) const
const char_type * | narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
const char_type * | scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
const char_type * | scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
const char_type * | tolower (char_type *__lo, const char_type *__hi) const
char_type | tolower (char_type __c) const
const char_type * | toupper (char_type *__lo, const char_type *__hi) const
char_type | toupper (char_type __c) const
char_type | widen (char __c) const
const char * | widen (const char *__lo, const char *__hi, char_type *__to) const

## Static Public Attributes
static const mask | alnum
static const mask | alpha
static const mask | blank
static const mask | cntrl
static const mask | digit
static const mask | graph
static locale::id | id
static const mask | lower
static const mask | print
static const mask | punct
static const mask | space
static const mask | upper
static const mask | xdigit

## Protected Member Functions
virtual | ~ctype ()
__wmask_type | _M_convert_to_wmask (const mask __m) const throw ()
void | _M_initialize_ctype () throw ()
virtual const char_type * | do_is (const char_type *__lo, const char_type *__hi, mask *__vec) const
virtual bool | do_is (mask __m, char_type __c) const
virtual char | do_narrow (char_type __c, char __dfault) const
virtual const char_type * | do_narrow (const char_type *__lo, const char_type *__hi, char __dfault, char *__to) const
virtual const char_type * | do_scan_is (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * | do_scan_not (mask __m, const char_type *__lo, const char_type *__hi) const
virtual const char_type * | do_tolower (char_type *__lo, const char_type *__hi) const
virtual char_type | do_tolower (char_type __c) const
virtual const char_type * | do_toupper (char_type *__lo, const char_type *__hi) const
virtual char_type | do_toupper (char_type __c) const
virtual char_type | do_widen (char __c) const
virtual const char * | do_widen (const char *__lo, const char *__hi, char_type *__to) const

## Static Protected Member Functions
static __c_locale | _S_clone_c_locale (__c_locale &__cloc) throw ()
static void | _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
static void | _S_destroy_c_locale (__c_locale &__cloc)
static __c_locale | _S_get_c_locale ()
static const char * | _S_get_c_name () throw ()
static __c_locale | _S_lc_ctype_c_locale (__c_locale __cloc, const char *__s)

## Protected Attributes
mask | _M_bit [16]
__c_locale | _M_c_locale_ctype
char | _M_narrow [128]
bool | _M_narrow_ok
wint_t | _M_widen [1+static_cast< unsigned char >(-1)]
__wmask_type | _M_wmask [16]

## Detailed Description

The ctype<wchar_t> specialization.

This class defines classification and conversion functions for the wchar_t type. It gets used by wchar_t streams for many I/O operations. The wchar_t specialization provides a number of optimizations as well.

ctype<wchar_t> inherits its public methods from __ctype_abstract_base<wchar_t>.

Definition at line 1196 of file locale_facets.h.

## Member Typedef Documentation

## ◆ __to_type

typedef const int* std::ctype_base::__to_type

Definition at line 44 of file ctype_base.h.

## ◆ __wmask_type

typedef wctype_t std::ctype< wchar_t >::__wmask_type

Definition at line 1202 of file locale_facets.h.

## ◆ char_type

typedef wchar_t std::ctype< wchar_t >::char_type

Typedef for the template parameter wchar_t.

Definition at line 1201 of file locale_facets.h.

## ◆ mask

typedef __ctype_abstract_base<wchar_t>::mask std::ctype< wchar_t >::mask

Definition at line 622 of file locale_facets.h.

## Constructor & Destructor Documentation

## ◆ ctype() [1/2]

std::ctype< wchar_t >::ctype | ( | size_t | __refs = 0 | ) |
| explicit

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters

  __refs | Passed to the base facet class.

## ◆ ctype() [2/2]

std::ctype< wchar_t >::ctype | ( | __c_locale | __cloc,
|  | size_t | __refs = 0 )
| explicit

Constructor performs static initialization.

This constructor is used to construct the initial C locale facet.

Parameters

  __cloc | Handle to C locale data.
  __refs | Passed to the base facet class.

## ◆ ~ctype()

virtual std::ctype< wchar_t >::~ctype | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ do_is() [1/2]

virtual const char_type * std::ctype< wchar_t >::do_is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec ) const
| protectedvirtual

Return a mask array.

This function finds the mask for each wchar_t in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the input.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __vec | Pointer to an array of mask storage.

Returns
  __hi.

## ◆ do_is() [2/2]

virtual bool std::ctype< wchar_t >::do_is | ( | mask | __m,
|  | char_type | __c ) const
| protectedvirtual

Test wchar_t classification.

This function finds a mask M for c and compares it to mask m.

do_is() is a hook for a derived facet to change the behavior of classifying. do_is() must always return the same result for the same input.

Parameters

  __c | The wchar_t to find the mask of.
  __m | The mask to compare against.

Returns
  (M & __m) != 0.

Implements std::__ctype_abstract_base< wchar_t >.

## ◆ do_narrow() [1/2]

virtual char std::ctype< wchar_t >::do_narrow | ( | char_type | __c,
|  | char | __dfault ) const
| protectedvirtual

Narrow wchar_t to char.

This virtual function converts the argument to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. For an underived ctype<wchar_t> facet, c will be cast to char and returned.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The wchar_t to convert.
  __dfault | Char to return if conversion fails.

Returns
  The converted char.

Implements std::__ctype_abstract_base< wchar_t >.

## ◆ do_narrow() [2/2]

virtual const char_type * std::ctype< wchar_t >::do_narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to ) const
| protectedvirtual

Narrow wchar_t array to char array.

This virtual function converts each wchar_t in the range [lo,hi) to char using the simplest reasonable transformation and writes the results to the destination array. For any wchar_t in the input that cannot be converted, dfault is used instead. For an underived ctype<wchar_t> facet, the argument will be copied, casting each element to char.

do_narrow() is a hook for a derived facet to change the behavior of narrowing. do_narrow() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __dfault | Char to use if conversion fails.
  __to | Pointer to the destination array.

Returns
  __hi.

## ◆ do_scan_is()

virtual const char_type * std::ctype< wchar_t >::do_scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Find wchar_t matching mask.

This function searches for and returns the first wchar_t c in [__lo,__hi) for which is(__m,c) is true.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to a matching wchar_t if found, else __hi.

Implements std::__ctype_abstract_base< wchar_t >.

## ◆ do_scan_not()

virtual const char_type * std::ctype< wchar_t >::do_scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Find wchar_t not matching mask.

This function searches for and returns a pointer to the first wchar_t c of [__lo,__hi) for which is(__m,c) is false.

do_scan_is() is a hook for a derived facet to change the behavior of match searching. do_is() must always return the same result for the same input.

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to a non-matching wchar_t if found, else __hi.

Implements std::__ctype_abstract_base< wchar_t >.

## ◆ do_tolower() [1/2]

virtual const char_type * std::ctype< wchar_t >::do_tolower | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Convert array to lowercase.

This virtual function converts each wchar_t in the range [lo,hi) to lowercase if possible. Other elements remain untouched.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

## ◆ do_tolower() [2/2]

virtual char_type std::ctype< wchar_t >::do_tolower | ( | char_type | __c | ) | const
| protectedvirtual

Convert to lowercase.

This virtual function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument.

do_tolower() is a hook for a derived facet to change the behavior of lowercasing. do_tolower() must always return the same result for the same input.

Parameters

  __c | The wchar_t to convert.

Returns
  The lowercase wchar_t if convertible, else __c.

Implements std::__ctype_abstract_base< wchar_t >.

## ◆ do_toupper() [1/2]

virtual const char_type * std::ctype< wchar_t >::do_toupper | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| protectedvirtual

Convert array to uppercase.

This virtual function converts each wchar_t in the range [lo,hi) to uppercase if possible. Other elements remain untouched.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

## ◆ do_toupper() [2/2]

virtual char_type std::ctype< wchar_t >::do_toupper | ( | char_type | __c | ) | const
| protectedvirtual

Convert to uppercase.

This virtual function converts the wchar_t argument to uppercase if possible. If not possible (for example, '2'), returns the argument.

do_toupper() is a hook for a derived facet to change the behavior of uppercasing. do_toupper() must always return the same result for the same input.

Parameters

  __c | The wchar_t to convert.

Returns
  The uppercase wchar_t if convertible, else __c.

Implements std::__ctype_abstract_base< wchar_t >.

## ◆ do_widen() [1/2]

virtual char_type std::ctype< wchar_t >::do_widen | ( | char | __c | ) | const
| protectedvirtual

Widen char to wchar_t.

This virtual function converts the char to wchar_t using the simplest reasonable transformation. For an underived ctype<wchar_t> facet, the argument will be cast to wchar_t.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char to convert.

Returns
  The converted wchar_t.

Implements std::__ctype_abstract_base< wchar_t >.

## ◆ do_widen() [2/2]

virtual const char * std::ctype< wchar_t >::do_widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to ) const
| protectedvirtual

Widen char array to wchar_t array.

This function converts each char in the input to wchar_t using the simplest reasonable transformation. For an underived ctype<wchar_t> facet, the argument will be copied, casting each element to wchar_t.

do_widen() is a hook for a derived facet to change the behavior of widening. do_widen() must always return the same result for the same input.

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start range.
  __hi | Pointer to end of range.
  __to | Pointer to the destination array.

Returns
  __hi.

## ◆ is() [1/2]

const char_type * std::__ctype_abstract_base< wchar_t >::is | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | mask * | __vec ) const
| inline

Return a mask array.

This function finds the mask for each char_type in the range [lo,hi) and successively writes it to vec. vec must have as many elements as the char array. It does so by returning the value of ctype<char_type>::do_is().

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __vec | Pointer to an array of mask storage.

Returns
  __hi.

Definition at line 191 of file locale_facets.h.

## ◆ is() [2/2]

bool std::__ctype_abstract_base< wchar_t >::is | ( | mask | __m,
|  | char_type | __c ) const
| inline

Test char_type classification.

This function finds a mask M for __c and compares it to mask __m. It does so by returning the value of ctype<char_type>::do_is().

Parameters

  __c | The char_type to compare the mask of.
  __m | The mask to compare against.

Returns
  (M & __m) != 0.

Definition at line 174 of file locale_facets.h.

## ◆ narrow() [1/2]

char std::__ctype_abstract_base< wchar_t >::narrow | ( | char_type | __c,
|  | char | __dfault ) const
| inline

Narrow char_type to char.

This function converts the char_type to char using the simplest reasonable transformation. If the conversion fails, dfault is returned instead. It does so by returning ctype<char_type>::do_narrow(__c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char_type to convert.
  __dfault | Char to return if conversion fails.

Returns
  The converted char.

Definition at line 336 of file locale_facets.h.

## ◆ narrow() [2/2]

const char_type * std::__ctype_abstract_base< wchar_t >::narrow | ( | const char_type * | __lo,
|  | const char_type * | __hi,
|  | char | __dfault,
|  | char * | __to ) const
| inline

Narrow array to char array.

This function converts each char_type in the input to char using the simplest reasonable transformation and writes the results to the destination array. For any char_type in the input that cannot be converted, dfault is used instead. It does so by returning ctype<char_type>::do_narrow(__lo, __hi, __dfault, __to).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __dfault | Char to use if conversion fails.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 358 of file locale_facets.h.

## ◆ scan_is()

const char_type * std::__ctype_abstract_base< wchar_t >::scan_is | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Find char_type matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is true. It does so by returning ctype<char_type>::do_scan_is().

Parameters

  __m | The mask to compare against.
  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  Pointer to matching char_type if found, else __hi.

Definition at line 207 of file locale_facets.h.

## ◆ scan_not()

const char_type * std::__ctype_abstract_base< wchar_t >::scan_not | ( | mask | __m,
|  | const char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Find char_type not matching a mask.

This function searches for and returns the first char_type c in [lo,hi) for which is(m,c) is false. It does so by returning ctype<char_type>::do_scan_not().

Parameters

  __m | The mask to compare against.
  __lo | Pointer to first char in range.
  __hi | Pointer to end of range.

Returns
  Pointer to non-matching char if found, else __hi.

Definition at line 223 of file locale_facets.h.

## ◆ tolower() [1/2]

const char_type * std::__ctype_abstract_base< wchar_t >::tolower | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Convert array to lowercase.

This function converts each char_type in the range [__lo,__hi) to lowercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_tolower(__lo, __hi).

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

Definition at line 281 of file locale_facets.h.

## ◆ tolower() [2/2]

char_type std::__ctype_abstract_base< wchar_t >::tolower | ( | char_type | __c | ) | const
| inline

Convert to lowercase.

This function converts the argument to lowercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_tolower(c).

Parameters

  __c | The char_type to convert.

Returns
  The lowercase char_type if convertible, else __c.

Definition at line 266 of file locale_facets.h.

## ◆ toupper() [1/2]

const char_type * std::__ctype_abstract_base< wchar_t >::toupper | ( | char_type * | __lo,
|  | const char_type * | __hi ) const
| inline

Convert array to uppercase.

This function converts each char_type in the range [lo,hi) to uppercase if possible. Other elements remain untouched. It does so by returning ctype<char_type>:: do_toupper(lo, hi).

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.

Returns
  __hi.

Definition at line 252 of file locale_facets.h.

## ◆ toupper() [2/2]

char_type std::__ctype_abstract_base< wchar_t >::toupper | ( | char_type | __c | ) | const
| inline

Convert to uppercase.

This function converts the argument to uppercase if possible. If not possible (for example, '2'), returns the argument. It does so by returning ctype<char_type>::do_toupper().

Parameters

  __c | The char_type to convert.

Returns
  The uppercase char_type if convertible, else __c.

Definition at line 237 of file locale_facets.h.

## ◆ widen() [1/2]

char_type std::__ctype_abstract_base< wchar_t >::widen | ( | char | __c | ) | const
| inline

Widen char to char_type.

This function converts the char argument to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __c | The char to convert.

Returns
  The converted char_type.

Definition at line 298 of file locale_facets.h.

## ◆ widen() [2/2]

const char * std::__ctype_abstract_base< wchar_t >::widen | ( | const char * | __lo,
|  | const char * | __hi,
|  | char_type * | __to ) const
| inline

Widen array to char_type.

This function converts each char in the input to char_type using the simplest reasonable transformation. It does so by returning ctype<char_type>::do_widen(c).

Note: this is not what you want for codepage conversions. See codecvt for that.

Parameters

  __lo | Pointer to start of range.
  __hi | Pointer to end of range.
  __to | Pointer to the destination array.

Returns
  __hi.

Definition at line 317 of file locale_facets.h.

## Member Data Documentation

## ◆ _M_bit

mask std::ctype< wchar_t >::_M_bit[16]
| protected

Definition at line 1213 of file locale_facets.h.

## ◆ _M_c_locale_ctype

__c_locale std::ctype< wchar_t >::_M_c_locale_ctype
| protected

Definition at line 1205 of file locale_facets.h.

## ◆ _M_narrow

char std::ctype< wchar_t >::_M_narrow[128]
| protected

Definition at line 1209 of file locale_facets.h.

## ◆ _M_narrow_ok

bool std::ctype< wchar_t >::_M_narrow_ok
| protected

Definition at line 1208 of file locale_facets.h.

## ◆ _M_widen

wint_t std::ctype< wchar_t >::_M_widen[1+static_cast< unsigned char >(-1)]
| protected

Definition at line 1210 of file locale_facets.h.

## ◆ _M_wmask

__wmask_type std::ctype< wchar_t >::_M_wmask[16]
| protected

Definition at line 1214 of file locale_facets.h.

## ◆ alnum

const mask std::ctype_base::alnum
| static

Definition at line 59 of file ctype_base.h.

## ◆ alpha

const mask std::ctype_base::alpha
| static

Definition at line 51 of file ctype_base.h.

## ◆ blank

const mask std::ctype_base::blank
| static

Definition at line 61 of file ctype_base.h.

## ◆ cntrl

const mask std::ctype_base::cntrl
| static

Definition at line 57 of file ctype_base.h.

## ◆ digit

const mask std::ctype_base::digit
| static

Definition at line 52 of file ctype_base.h.

## ◆ graph

const mask std::ctype_base::graph
| static

Definition at line 56 of file ctype_base.h.

## ◆ id

locale::id std::ctype< wchar_t >::id
| static

The facet id for ctype<wchar_t>.

Definition at line 1219 of file locale_facets.h.

## ◆ lower

const mask std::ctype_base::lower
| static

Definition at line 50 of file ctype_base.h.

## ◆ print

const mask std::ctype_base::print
| static

Definition at line 55 of file ctype_base.h.

## ◆ punct

const mask std::ctype_base::punct
| static

Definition at line 58 of file ctype_base.h.

## ◆ space

const mask std::ctype_base::space
| static

Definition at line 54 of file ctype_base.h.

## ◆ upper

const mask std::ctype_base::upper
| static

Definition at line 49 of file ctype_base.h.

## ◆ xdigit

const mask std::ctype_base::xdigit
| static

Definition at line 53 of file ctype_base.h.

The documentation for this class was generated from the following file:

- locale_facets.h